/*
	keyfunc.c
*/

#include <ryosuke.h>

void	key_init()
	{
	KYB_init();
	}
	
char	key_get()
	{
	uint	code, encode;
	for (;;) {
		code = KYB_read( 0, &encode );
		if ( (code & 0xffff) == 0xffff  &&  (encode & 0xff00) == 0xff00 )
			continue;
		break;
		}
	return (char) code;
	}

int		key_chk()		/* L[͂Ȃ 1   Ȃ 0 */
	{
	uint	code, encode;
	int		chrcnt;
	code = KYB_inpchk( &chrcnt, &encode );
	if ( chrcnt == 0 )
		return 0;
	else
		return 1;
	}

char	key_read()		/* L[͂ ̃R[h Ȃ 0 */
	{
	if (key_chk())
		return key_get();
	else
		return 0;
	}

void	key_clrbuf()
	{
	KYB_clrbuf();
	}

/* end of keyfunc.c */
