;	CuEOtBbN
;	(c) MATSUUCHI Ryosuke in Dec,1992
;
;	gpset.asm
;
;	1992. 6.13(Sat)
;	1992. 7. 9(Thu)
;	1992.12.28(Sun)

		public	gpset,_gpset
		extrn	_gwrtreg:near
		extrn	__SetVramSeg:near, __AddVramBase_ebx:near
		
		include	grplib.inc
		
		assume	cs:cseg, ds:dseg


dseg segment dword 'DATA'
dseg ends


cseg segment dword 'CODE'

;---------------------------------------------------------------
;	_gpset : _̕`
;		in  EAX,EBX : W
;		    ECX     : F
;		    EDX     : Zw(0=PSET 4=XOR)
;
;	void gpset(int x, int y, int col, int mode)
;---------------------------------------------------------------



		align	4

_gpset		proc
		pushad
		mov	esi,[_nowscrmod]	;esi ɉʃ[h
		cmp	si,2
		jle	#end
		cmp	si,4
		jg	#1
		call	gpset_16
		jmp	#end
#1:		cmp	si,8
		jg	#2
		call	gpset_32_1
		jmp	#end
#2:		cmp	si,11
		jg	#3
		call	gpset_32_2
		jmp	#end
#3:		cmp	si,14
		jg	#4
		call	gpset_256
		jmp	#end
#4:		cmp	si,18
		jg	#end
		call	gpset_32_3
#end:		popad
		ret
_gpset		endp



gpset		proc
		push	ebx
		pushfd
		mov	eax,[esp+8+4]		;eax  x W
		mov	ebx,[esp+8+8]		;ebx  y W
		mov	ecx,[esp+8+12]		;ecx ɐF
		mov	edx,[esp+8+16]		;edx ɉZw
		call	_gpset
		popfd
		pop	ebx
		ret
gpset		endp



		align	4


; PSET ̃Tu[`i16FPSETj
;----------------------------------------------------------------------------


gpset_16	proc
		mov	esi,eax			;edi Ƀ}XNp^[
		mov	edi,1111b
		and	esi,7
		lea	esi,[esi*4]
		or	esi,esi
		jz	#1
		xchg	ecx,esi			;}XNp^[Vtg
		shl	edi,cl			;łɃJ[R[h
		shl	esi,cl			;Vtg
		xchg	ecx,esi
		and	ecx,edi
#1:		shr	eax,1			;ebx ɃAhX
		and	eax,0fffffffch
		lea	ebx,[ebx*8]
		lea	ebx,[ebx*8]
		lea	ebx,[ebx*8+eax]
		call	__AddVramBase_ebx
		push	es			;es ۑ
		call	__SetVramSeg		;es ݃y[W̃ZN^
		mov	eax,es:[ebx]		;eax  VRAM̓e
		or	edx,edx			;edx(Zw)ɂ蕪
		jnz	#3
		not	edi			;PSETZ
		and	eax,edi
		or	eax,ecx
		jmp	#4
#3:		cmp	edx,4
		jnz	#5
		xor	eax,ecx			;XORZ
		jmp	#4
#5:		cmp	edx,6
		jnz	#4
		or	ecx,ecx			;MATTEiO߁jZ
		jz	#6
		not	edi
		and	eax,edi
		or	eax,ecx
#4:		mov	es:[ebx],eax		;eax ̒l VRAM ɏ
#6:		;
		pop	es			;es 𕜋A
		ret
gpset_16	endp


; PSET ̃Tu[`iRFPSET [512*256sNZ[h]j
;----------------------------------------------------------------------------


gpset_32_1	proc
		lea	ebx,[ebx*8]		;ebx  ebx*512+eax*2 
		lea	ebx,[ebx*8]		;(VRAM AhX)
		lea	ebx,[ebx*4+eax]
		lea	ebx,[ebx*2]
		call	gpset32sub
		ret
gpset_32_1	endp



gpset_32_2	proc
		lea	ebx,[ebx*8]		;ebx  ebx*1024+eax*2 
		lea	ebx,[ebx*8]		;(VRAM AhX)
		lea	ebx,[ebx*8+eax]
		lea	ebx,[ebx*2]
		call	gpset32sub
		ret
gpset_32_2	endp


; PSET ̃Tu[`i256FPSETj
;----------------------------------------------------------------------------


gpset_256	proc
		;܂ĂȂ[
		push	ds
		mov	ax,10ch
		mov	ds,ax
		mov	dword ptr ds:[0],0ffffffffh
		pop	ds
		ret
gpset_256	endp


; PSET ̃Tu[`iRFPSET [512*512sNZ[h]j
;----------------------------------------------------------------------------


gpset_32_3	proc
		lea	ebx,[ebx*8]		;ebx  ebx*1024+eax*2 
		lea	ebx,[ebx*8]		;(VRAM AhX)
		lea	ebx,[ebx*8+eax]
		lea	ebx,[ebx*2]
		call	gpset32sub
		ret
		;;܂ĂȂ[
		;push	ds
		;mov	ax,10ch
		;mov	ds,ax
		;mov	word ptr ds:[0],07fffh
		;pop	ds
		;ret
gpset_32_3	endp


; RFPSET ̃Tu[`
;	ebx ɃItZbgAedx ɉZwAecx ɃJ[R[h
;	ݒ肳Ă邱ƂOɁA
;	x[XItZbgZAZN^ݒAVRAM ւ݂̏sB
;------------------------------------------------------------------------

gpset32sub	proc
		;  in  ebx:ʓAhX
		call	__AddVramBase_ebx
		push	es			;es ۑ
		call	__SetVramSeg		;es  ݃y[W̃ZN^
		or	edx,edx			;edx(Zw) ɂ蕪
		jnz	#2
		mov	es:[ebx],cx		;Z PSET
		jmp	#3
#2:		cmp	edx,4
		jnz	#4
		xor	es:[ebx],cx		;Z XOR
		jmp	#3
#4:		cmp	edx,6
		jnz	#3
		or	cx,cx			;Z MATTE (0)
		jz	#5
		mov	es:[ebx],cx
#5:		;
#3:		pop	es			;es A
		ret
gpset32sub	endp



cseg ends

end
